/*
Script for Kuu
	by PizzaDarius25 (Original Follower Script by SteelT)
	

This is for Linne in which Kuu follows Linne everywhere she goes.
*/

//Freeslot the required stuff
freeslot(
	"SPR_LNKU",
	"S_KUUIDLE",
	"S_KUUFLY",
	"S_KUUACT1_1",
	"S_KUUACT1_2",
	"S_KUUACT1_3",
	"S_KUUACT1_4",
	"S_KUUACT2_1",
	"S_KUUACT2_2",
	"S_KUUACT2_3",
	"S_KUUACT2_4",
	"MT_KUU"
)

mobjinfo[MT_KUU] = {
	doomednum = -1,
	spawnstate = S_KUUIDLE,
	spawnhealth = 1,
	painchance = 200,
	speed = 3,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	reactiontime = 32,
	activesound = sfx_None,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP,
	raisestate = S_NULL
}

states[S_KUUIDLE] = {
	sprite = SPR_LNKU,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 5,
	nextstate = S_KUUIDLE
}

states[S_KUUFLY] = {
	sprite = SPR_LNKU,
	frame = E|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 5,
	nextstate = S_KUUFLY
}

states[S_KUUACT1_1] = {
	sprite = SPR_LNKU,
	frame = I,
	tics = 3,
	var1 = 0,
	var2 = 0,
	nextstate = S_KUUACT1_2
}

states[S_KUUACT1_2] = {
	sprite = SPR_LNKU,
	frame = J,
	tics = 3,
	var1 = 0,
	var2 = 0,
	nextstate = S_KUUACT1_3
}

states[S_KUUACT1_3] = {
	sprite = SPR_LNKU,
	frame = K,
	tics = 3,
	var1 = 0,
	var2 = 0,
	nextstate = S_KUUACT1_4
}

states[S_KUUACT1_4] = {
	sprite = SPR_LNKU,
	frame = J,
	tics = 3,
	var1 = 0,
	var2 = 0,
	nextstate = S_KUUACT1_1
}


states[S_KUUACT2_1] = {
	sprite = SPR_LNKU,
	frame = I,
	tics = 3,
	nextstate = S_KUUACT2_2
}

states[S_KUUACT2_2] = {
	sprite = SPR_LNKU,
	frame = J,
	tics = 1,
	nextstate = S_KUUACT2_3
}

states[S_KUUACT2_3] = {
	sprite = SPR_LNKU,
	frame = K,
	tics = 4,
	nextstate = S_KUUACT2_4
}

states[S_KUUACT2_4] = {
	sprite = SPR_LNKU,
	frame = J,
	tics = 1,
	nextstate = S_KUUACT2_1
}

addHook("MobjThinker", function(mo)
	if mo and mo.skin == "linne" and mo.player //Skin check
		local player = mo.player
		if not player.mo.kuu
			player.mo.kuu = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_KUU)
			player.mo.kuu.angle = player.mo.angle
			player.mo.kuu.flags2 = player.mo.flags2
			player.mo.kuu.scale = player.mo.scale
			player.mo.kuu.target = player.mo
		end
	elseif mo and mo.skin ~= "linne" and mo.kuu and mo.kuu.valid then // Not using Linne but still has Kuu with them.
		P_RemoveMobj(mo.kuu)
		mo.kuu = nil
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	-- Thinker for Kuu
	if mo and mo.valid then
		if mo.target and mo.target.valid and mo.target.player and mo.target.player.valid then
			local tg = mo.target
			local totz

			-- Colorize Kuu if the player has invincibility, grow etc.
			mo.color = tg.color
			mo.colorized = tg.colorized

			-- Check for gravity flip
			if (mo.eflags & MFE_VERTICALFLIP)
				totz = (tg.z) - (tg.height)
			else
				totz = (tg.z) + (tg.height)
			end

			local mangle = FixedAngle(((leveltime * 5) % 360) << FRACBITS)
			mo.scale = tg.scale
			mo.angle = tg.angle
			mo.eflags = tg.eflags
			mo.flags2 = tg.flags2

			if (tg.player.exiting > 0 and K_IsPlayerLosing(tg.player) == true) or tg.player.kartstuff[k_spinouttimer] > 0 or tg.health == 0
				if not (mo.state >= S_KUUACT2_1 and mo.state <= S_KUUACT2_4)
					mo.state = S_KUUACT2_1
				end
				mo.z = totz
				P_TeleportMove(mo, tg.x, tg.y, totz)
				mo.angle = tg.angle
			end

			if tg.health > 0 and tg.player.kartstuff[k_spinouttimer] == 0 then
				if tg.player.speed > 0 or (tg.momx + tg.momy + tg.momz) > 0 then // If player is moving
					if mo.prevtpos == nil then
						mo.prevtpos = {}
					end

					if not (mo.state == S_KUUFLY)
						mo.state = S_KUUFLY
					end
					local trailby = 2

					if #mo.prevtpos >= trailby then
						local e = mo.prevtpos[trailby]
						local etotz

						if (mo.eflags & MFE_VERTICALFLIP)
							etotz = e.z - (tg.height) - (sin(FixedAngle(leveltime*5*FRACUNIT))*8)
						else
							etotz = e.z + (tg.height) + (sin(FixedAngle(leveltime*5*FRACUNIT))*8)
						end

						mo.prevtpos[trailby] = nil
						P_TeleportMove(mo, e.x, e.y, etotz)
					end

					table.insert(mo.prevtpos, 1, {x = tg.x, y = tg.y, z = tg.z})
				else -- If player is idle
					P_TeleportMove(mo, tg.x, tg.y, totz)

					if tg.player.exiting > 0 and K_IsPlayerLosing(tg.player) == false
						if not (mo.state >= S_KUUACT1_1 and mo.state <= S_KUUACT2_4)
							mo.state = S_KUUACT1_1
						end
					elseif tg.player.exiting > 0 and K_IsPlayerLosing(tg.player) == true
						if not (mo.state >= S_KUUACT2_1 and mo.state <= S_KUUACT2_4)
							mo.state = S_KUUACT2_1
						end
					else
						if not (mo.state == S_KUUIDLE)
							mo.state = S_KUUIDLE
						end
					end

					mo.angle = tg.angle
					mo.momx = sin(mangle) * (tg.radius>>FRACBITS)
					mo.momy = cos(mangle) * (tg.radius>>FRACBITS)
				end
			end
		end
	end

	if mo and (not mo.target or not mo.target.valid) or (not mo.target.player or not mo.target.valid) then
		P_RemoveMobj(mo)
    end

end, MT_KUU)